<?PHP

/* 
  Plugin Name: Comment Toolbar
  Plugin URI: http://www.cristianofino.net/post/Comment-toolbar-plugin-per-Wordpress.aspx
  Description: Adds Comments Navigation, Quote and Reply buttons (or links) at the beginning or end of each comment. You can customize every aspect of the toolbar.
  Version: 1.2.0
  Author: Cristiano Fino
  Author URI: http://www.cristianofino.net/
*/

/* 
  Copyright 2008 Cristiano Fino (email: cristiano.fino@bbs.olografix.org)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/


/* Adding plugin if not already exists function */ 

if (function_exists('cf_comment_toolbar')) 
{
	add_filter('the_content', 'cf_comment_toolbar_js', 99);
	add_filter('comment_text', 'cf_comment_toolbar', 99);
	
	/* Adding parameters */
	add_option('cf_comment_toolbar_lbl_reply', 'Reply', 'label of Reply button/link');
	add_option('cf_comment_toolbar_lbl_quote', 'Quote', 'label of Quote button/link');
	add_option('cf_comment_toolbar_lbl_wrote', 'wrote', 'text of Wrote message');

	add_option('cf_comment_toolbar_position', 'T', 'toolbar position: T - Top, B - Bottom');
	add_option('cf_comment_toolbar_align', 'right', 'toolbar alignment: left, right, center, css');
	add_option('cf_comment_toolbar_style','B','toolbar style: B - Buttons, L - Links');
	add_option('cf_comment_toolbar_separator','&nbsp;|&nbsp;','separator characters');
	
	add_option('cf_comment_toolbar_navigation','1','display or not comment navigation link: 1 - Display, 0 - Hide');
	add_option('cf_comment_toolbar_anchor_prefix','comment-','text before the comment on anchor link');	

	/* Adding menu and parameters page */
	add_action('admin_menu', 'cf_comment_toolbar_admin_menu');
}

/* Adding parameters page */

function cf_comment_toolbar_admin_menu()
{
	add_submenu_page('plugins.php', 'Comment Toolbar Plugin Options', 'Comment Toolbar', 5, basename(__FILE__),'cf_comment_toolbar_options_page'); 
}

/* Options page */

function cf_comment_toolbar_options_page() {

    $hidden_field_name = 'mt_submit_hidden';
    
    $opt_name_lbl_reply = 'cf_comment_toolbar_lbl_reply';
    $opt_name_lbl_quote = 'cf_comment_toolbar_lbl_quote';
    $opt_name_lbl_wrote = 'cf_comment_toolbar_lbl_wrote';
    $opt_name_position = 'cf_comment_toolbar_position';
    $opt_name_style = 'cf_comment_toolbar_style';
    $opt_name_align = 'cf_comment_toolbar_align';
    $opt_name_separator = 'cf_comment_toolbar_separator';
    $opt_name_navigation = 'cf_comment_toolbar_navigation';
    $opt_name_anchor_prefix = 'cf_comment_toolbar_anchor_prefix';

    
    $data_field_name_lbl_reply = 'cf_comment_toolbar_lbl_reply';
    $data_field_name_lbl_quote = 'cf_comment_toolbar_lbl_quote';
    $data_field_name_lbl_wrote = 'cf_comment_toolbar_lbl_wrote';
    $data_field_name_position = 'cf_comment_toolbar_position';
    $data_field_name_style = 'cf_comment_toolbar_style';
    $data_field_name_align = 'cf_comment_toolbar_align';
    $data_field_name_separator = 'cf_comment_toolbar_separator';
    $data_field_name_navigation = 'cf_comment_toolbar_navigation';
    $data_field_name_anchor_prefix = 'cf_comment_toolbar_anchor_prefix';    

    // Read in existing option value from database
    $opt_val_lbl_reply = get_option($opt_name_lbl_reply);
    $opt_val_lbl_quote = get_option($opt_name_lbl_quote);
    $opt_val_lbl_wrote = get_option($opt_name_lbl_wrote);
    $opt_val_position = get_option($opt_name_position);
    $opt_val_style = get_option($opt_name_style);
    $opt_val_align = get_option($opt_name_align);
    $opt_val_separator = get_option($opt_name_separator);
    $opt_val_navigation = get_option($opt_name_navigation);
    $opt_val_anchor_prefix = get_option($opt_name_anchor_prefix);

    if( $_POST[ $hidden_field_name ] == 'Y' ) {
        $opt_val_lbl_reply = $_POST[$data_field_name_lbl_reply];
        $opt_val_lbl_quote = $_POST[$data_field_name_lbl_quote];
        $opt_val_lbl_wrote = $_POST[$data_field_name_lbl_wrote];
        $opt_val_position = $_POST[$data_field_name_position];
        $opt_val_style = $_POST[$data_field_name_style];
        $opt_val_align = $_POST[$data_field_name_align];
        $opt_val_separator = $_POST[$data_field_name_separator];
		$opt_val_navigation = $_POST[$data_field_name_navigation];
		$opt_val_anchor_prefix = $_POST[$data_field_name_anchor_prefix];
        
        
        update_option($opt_name_lbl_reply, $opt_val_lbl_reply);
        update_option($opt_name_lbl_quote, $opt_val_lbl_quote);
        update_option($opt_name_lbl_wrote, $opt_val_lbl_wrote);
        update_option($opt_name_style, $opt_val_style);
        update_option($opt_name_align, $opt_val_align);
        update_option($opt_name_position, $opt_val_position);		
        update_option($opt_name_separator, $opt_val_separator);		
        update_option($opt_name_navigation, $opt_val_navigation);		
        update_option($opt_name_anchor_prefix, $opt_val_anchor_prefix);		
       
?>
	<div id="message" class="updated fade"><p><strong><?php _e('Options saved.', 'mt_trans_domain' ); ?></strong></p></div>

<?php
    }
    echo '<div class="wrap">';
    echo "<h2>" . __( 'Comment Toolbar Plugin Options', 'mt_trans_domain' ) . "</h2>";
    ?>

	<form name="form_Wikiterm_Options" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
	<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">	
	<p style="text-align: left; line-height: 32px; padding-left:25px">
	<?php _e("Label of 'Reply' button (or link):", 'mt_trans_domain' ); ?>&nbsp;
	<input type="text" style="vertical-align: middle" name="<?php echo $data_field_name_lbl_reply; ?>" value="<?php echo $opt_val_lbl_reply; ?>" size="20">&nbsp;<em><?php _e("(to not display, leave blank)", 'mt_trans_domain' ); ?></em><br />
	<?php _e("Label of 'Quote' button (or link):", 'mt_trans_domain' ); ?>&nbsp;
	<input type="text" style="vertical-align: middle" name="<?php echo $data_field_name_lbl_quote; ?>" value="<?php echo $opt_val_lbl_quote; ?>" size="20">&nbsp;<em><?php _e("(to not display, leave blank)", 'mt_trans_domain' ); ?></em><br /><br />
	
	<?php _e("Text message of 'Quote' action:", 'mt_trans_domain' ); ?>&nbsp;
	<input type="text" style="vertical-align: middle" name="<?php echo $data_field_name_lbl_wrote; ?>" value="<?php echo $opt_val_lbl_wrote; ?>" size="30"><br />
	<?php _e("Characters of separation between the buttons (or links):", 'mt_trans_domain' ); ?>&nbsp;
	<input type="text" style="vertical-align: middle" name="<?php echo $data_field_name_separator; ?>" value="<?php echo $opt_val_separator; ?>" size="10">&nbsp;<em><?php _e("(you can insert HTML code also)", 'mt_trans_domain' ); ?></em><br /><br />
	<?php _e("Text to insert in anchor link, before comment ID :", 'mt_trans_domain' ); ?>&nbsp;
	<input type="text" style="vertical-align: middle" name="<?php echo $data_field_name_anchor_prefix; ?>" value="<?php echo $opt_val_anchor_prefix; ?>" size="20"><br /><em><?php _e("(Insert <b>CO_</b> if you do not know the format's links to comments of your theme)", 'mt_trans_domain' ); ?></em><br /><br />
	
	<?php _e("Toolbar style:", 'mt_trans_domain' ); ?>&nbsp;
	<select style="vertical-align: middle" name="<?php echo $data_field_name_style; ?>">
		<option value="B" <?php if($opt_val_style == "B") echo 'selected' ?> ><?php _e("Buttons", 'mt_trans_domain' ); ?></option> 
		<option value="L" <?php if($opt_val_style == "L") echo 'selected' ?> ><?php _e("Links", 'mt_trans_domain' ); ?> </option>
	</select>&nbsp;-&nbsp;
	<?php _e("Toolbar position:", 'mt_trans_domain' ); ?>&nbsp;
	<select style="vertical-align: middle" name="<?php echo $data_field_name_position; ?>">
		<option value="T" <?php if($opt_val_position == "T") echo 'selected' ?> ><?php _e("Top of comment", 'mt_trans_domain' ); ?></option> 
		<option value="B" <?php if($opt_val_position == "B") echo 'selected' ?> ><?php _e("Bottom of comment", 'mt_trans_domain' ); ?></option> 
	</select>&nbsp;-&nbsp;
	<?php _e("Toolbar alignment:", 'mt_trans_domain' ); ?>&nbsp;	
	<select style="vertical-align: middle" name="<?php echo $data_field_name_align; ?>">
		<option value="left" <?php if($opt_val_align == "left") echo 'selected' ?> ><?php _e("Left", 'mt_trans_domain' ); ?></option> 
		<option value="right" <?php if($opt_val_align == "right") echo 'selected' ?> ><?php _e("Right", 'mt_trans_domain' ); ?></option> 
		<option value="center" <?php if($opt_val_align == "center") echo 'selected' ?> ><?php _e("Center", 'mt_trans_domain' ); ?></option> 
		<option value="css" <?php if($opt_val_align == "css") echo 'selected' ?> ><?php _e("CSS style settings", 'mt_trans_domain' ); ?></option> 
	</select><br />
	<?php _e("Show buttons to navigate on your comments :", 'mt_trans_domain' ); ?>&nbsp;
	<select style="vertical-align: middle" name="<?php echo $data_field_name_navigation; ?>">
		<option value="0" <?php if($opt_val_navigation == "0") echo 'selected' ?> ><?php _e("No", 'mt_trans_domain' ); ?></option> 
		<option value="1" <?php if($opt_val_navigation== "1") echo 'selected' ?> ><?php _e("Yes", 'mt_trans_domain' ); ?> </option>
	</select>
	
	</p>
	<p class="submit">
	<input type="submit" name="Submit" value="<?php _e('Update Options', 'mt_trans_domain' ) ?>" />
	</p>
	</form>
	</div>

<?php
}

/* Core function of Comment Toolbar */

function cf_comment_toolbar_js($body = '')
{
	if (is_single() && comments_open())
	{
		$msg_wrote = get_option('cf_comment_toolbar_lbl_wrote');
	?>
	<script type="text/javascript">
	<!--//
	//
	// Wordpress Comment Toolbar plugin: Javascript functions
	//
	// Plugin release:   1.0
	// Author:           Cristiano Fino
	// WebSite:          http://www.cristianofino.net
	//
	function CF_Quote(otextarea, oauthor) {
	  var otext = document.getElementById(otextarea);
	  var otextCommentArea = document.getElementById("comment");
	  if (window.getSelection)
	     var sel = window.getSelection();
	  else if (document.getSelection)
	     var sel = document.getSelection();
	  else if (document.selection) {
	     var sel = document.selection.createRange().text; }        
	  if (otext.innerText){
	      if (sel != "") otextCommentArea.value += "<b>" + oauthor + "</b> <?PHP echo $msg_wrote; ?>:\n<blockquote>" + sel + "</blockquote>\n"; 
	        else otextCommentArea.value += "<b>" + oauthor + "</b> <?PHP echo $msg_wrote; ?>:\n<blockquote>" + otext.innerText + "</blockquote>\n";
	  }
	  else { 
	      if (sel != "") otextCommentArea.value += "<b>" + oauthor + "</b> <?PHP echo $msg_wrote; ?>:\n<blockquote>" + sel + "</blockquote>\n"; 
	        else otextCommentArea.value += "<b>" + oauthor + "</b> <?PHP echo $msg_wrote; ?>:\n<blockquote>" + otext.textContent + "</blockquote>\n";
	  }
	  otextCommentArea.focus();
	}
	function CF_Reply(oauthor) {
	  var otextCommentArea = document.getElementById("comment");
	  otextCommentArea.value += "<b>@ " + oauthor + "</b>:\n";
	  otextCommentArea.focus();
	}
	//-->
	</script> 	
	<?PHP
	}
	return $body;	
}

function cf_comment_toolbar($content = '')
{
	global $comment;
	
	/* if comments are closed, or comment is tracback or pingback, */
	/* or comment is not approved, or is admin page, then exit     */
	if (!comments_open() || is_admin() || $comment->comment_approved == 0 ||
		$comment->comment_type == "trackback" || $comment->comment_type == "pingback") return $content;
	
	/* typecasting local variables and loading plug-in properties */ 
	$ID = (string)$comment->comment_ID;
	$Post_ID = (string)$comment->comment_post_ID;
	$Author = (string)$comment->comment_author;
	$lbl_reply = (string)get_option('cf_comment_toolbar_lbl_reply');
	$lbl_quote = (string)get_option('cf_comment_toolbar_lbl_quote');
	$position = (string)get_option('cf_comment_toolbar_position');
	$style = (string)get_option('cf_comment_toolbar_style');
	$align = (string)get_option('cf_comment_toolbar_align');	
	$separator = (string)get_option('cf_comment_toolbar_separator');
	$navigation = (string)get_option('cf_comment_toolbar_navigation');
	$anchor_prefix = (string)get_option('cf_comment_toolbar_anchor_prefix');
		
	$new_content = "<span id=\"co_".$ID."\">".$content."</span>";
	
	/* creating toolbar */
	$toolbar = "<div class=\"comment-toolbar\" ";
	if ($align != "css") $toolbar .= "style=\"text-align: ".$align."\"";
	$toolbar .= ">";
	
	/* adding comment navigation links */
	if ($navigation == "1" && !function_exists(paged_comments_show_all)) 
	{
		$approved_comments = get_approved_comments($Post_ID);
		$post_permalink = get_permalink($Post_ID);
		
		if (Count($approved_comments) > 1)
		{
			/* Searching the comment position */
			$cur_pos_comment = 0;
			for ($i=0; $i < Count($approved_comments); $i++)
			{
				if ($approved_comments[$i]->comment_ID == $ID) 
				{
					$cur_pos_comment = $i; break;
				}
			}
			/* Print First and Previous comment button (if present) */
			if ($cur_pos_comment >= 1) 
			{
				if ($style == "L")
					$toolbar .= "<a href=\"#".$anchor_prefix.$approved_comments[0]->comment_ID."\" title=\"First comment\">&lt;&lt;</a>";
				else
					$toolbar .= "<input type=\"button\" value=\"&lt;&lt;\" onclick=\"javascript:void(document.location.href='".$post_permalink."#".$anchor_prefix.$approved_comments[0]->comment_ID."')\" />";
				if ($separator != '' && $style == "L")
					$toolbar .= ' '.$separator.' ';
				if ($style == "L")
					$toolbar .= "<a href=\"#".$anchor_prefix.$approved_comments[$cur_pos_comment - 1]->comment_ID."\" title=\"Previous comment\">&lt;</a>";
				else
					$toolbar .= "<input type=\"button\" value=\"&lt;\" onclick=\"javascript:void(document.location.href='".$post_permalink."#".$anchor_prefix.$approved_comments[$cur_pos_comment - 1]->comment_ID."')\" />";				
				if (($lbl_reply != '' || $lbl_quote != '') && $separator != '' && $style == "L")
					$toolbar .= ' '.$separator.' ';
			}
			/* Print Next and Last comment button (if present) */
			if ($cur_pos_comment < Count($approved_comments) - 1) 
			{
				if ($style == "L")
					$toolbar .= "<a href=\"#".$anchor_prefix.$approved_comments[$cur_pos_comment + 1]->comment_ID."\" title=\"Next comment\">&gt;</a>";
				else
					$toolbar .= "<input type=\"button\" value=\"&gt;\" onclick=\"javascript:void(document.location.href='".$post_permalink."#".$anchor_prefix.$approved_comments[$cur_pos_comment + 1]->comment_ID."')\" />";
				if ($separator != '' && $style == "L")
					$toolbar .= ' '.$separator.' ';
				if ($style == "L")
					$toolbar .= "<a href=\"#".$anchor_prefix.$approved_comments[Count($approved_comments) - 1]->comment_ID."\" title=\"Last comment\">&gt;&gt;</a>";
				else
					$toolbar .= "<input type=\"button\" value=\"&gt;&gt;\" onclick=\"javascript:void(document.location.href='".$post_permalink."#".$anchor_prefix.$approved_comments[Count($approved_comments) - 1]->comment_ID."')\" />";				
				if (($lbl_reply != '' || $lbl_quote != '') && $separator != '' && $style == "L")
					$toolbar .= ' '.$separator.' ';
			}
		}		
	}
	
	/* adding reply and quote links */
	if ($lbl_reply != '')
	{
		if ($style == "L")
			$toolbar .= "<a href=\"#\" onclick=\"CF_Reply('".$Author."'); return false;\">".$lbl_reply."</a>";
		else
			$toolbar .= "<input type=\"button\" value=\"".$lbl_reply."\" onclick=\"CF_Reply('".$Author."');\" />";
	}
	if ($lbl_quote != '')
	{
		if ($lbl_reply != '' && $separator != '' && $style == "L")
			$toolbar .= ' '.$separator.' ';
		if ($style == "L")
			$toolbar .= "<a href=\"#\" onclick=\"CF_Quote('co_".$ID."','".$Author."'); return false;\">".$lbl_quote."</a>";
		else
			$toolbar .= "<input type=\"button\" value=\"".$lbl_quote."\" onclick=\"CF_Quote('co_".$ID."','".$Author."');\" />";
	}
	$toolbar .= "</div>";
	
	if ($position == 'T')
		$new_content = $toolbar.$new_content;
	else
		$new_content = $new_content.$toolbar;
	
	return $new_content;
}
?>